package net.cattaka.rdbassistant.sqlite;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.JLabel;

import net.cattaka.rdbassistant.config.RdbaConnectionInfo;
import net.cattaka.rdbassistant.gui.connectioninfo.RdbaConnectionInfoEditor;
import net.cattaka.swing.datainputpanel.DIPInfoFile;
import net.cattaka.swing.text.StdTextField;
import net.cattaka.util.MessageBundle;

public class SqliteRdbaConnectionInfoEditor extends RdbaConnectionInfoEditor {
	private static final long serialVersionUID = 1L;
	private StdTextField labelField;
	private DIPInfoFile databaseField;
	
	public SqliteRdbaConnectionInfoEditor() {
		makeLayout();
	}
	
	private void makeLayout() {
		JLabel labelLabel = new JLabel(MessageBundle.getMessage("label"));
		JLabel databaseLabel = new JLabel(MessageBundle.getMessage("database"));
		labelField = new StdTextField();
		databaseField = new DIPInfoFile("", "", DIPInfoFile.MODE_OPEN);
		
		GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		
		gbc.fill = GridBagConstraints.NONE;
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx=0.0;
		gbc.weighty=0.0;
		gbl.setConstraints(labelLabel, gbc);
		gbc.gridy++;
		gbl.setConstraints(databaseLabel, gbc);

		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.gridx = 1;
		gbc.gridy = 0;
		gbc.weightx=1.0;
		gbl.setConstraints(labelField, gbc);
		gbc.gridy++;
		gbl.setConstraints(databaseField.getComponent(), gbc);

		this.setLayout(gbl);
		this.add(labelLabel);
		this.add(labelField);
		this.add(databaseLabel);
		this.add(databaseField.getComponent());
	}
	
	@Override
	public boolean load(RdbaConnectionInfo rdbaConnectionInfo) {
		if (!(rdbaConnectionInfo instanceof SqliteRdbaConnectionInfo)) {
			return false;
		}
		SqliteRdbaConnectionInfo info = (SqliteRdbaConnectionInfo)rdbaConnectionInfo;
		labelField.setText(info.getLabel());
		databaseField.setStringValue(info.getDatabase());
		return false;
	}

	@Override
	public RdbaConnectionInfo save() {
		SqliteRdbaConnectionInfo info = new SqliteRdbaConnectionInfo();
		info.setLabel(labelField.getText());
		info.setDatabase(String.valueOf(databaseField.getStringValue()));
		return info;
	}
}
